

stages:
  - build
  - test
  - publish
  - deploy

# BUILD_PHASE
#=============
build_phase:
  variables:
    SPRING_PROFILES_ACTIVE: "prod"
  stage: build
  script: ./gradlew --build-cache assemble --info
  image: gradle:6.0-jdk11
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: push
    paths:
      - build
      - .gradle
  only:
    - master

# TEST_PHASE
#=============
test_phase:
  variables:
    SPRING_PROFILES_ACTIVE: "prod"
  stage: test
  script: ./gradlew test check --info
  image: gradle:6.0-jdk11
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: pull
    paths:
      - build
      - .gradle
  only:
    - master

# PUBLISH_PHASE
#=============

publish_phase:
  stage: publish
  before_script:
    - echo $DOCKER_REPO_PASSWORD | docker login --username $DOCKER_REPO_USERNAME --password-stdin
  image: docker:git
  services:
    - docker:19.03.5-dind
  script:
    - docker build -t $DOCKER_REPO_USERNAME/$DOCKER_REPO_NAME:doc .
    - docker push $DOCKER_REPO_USERNAME/$DOCKER_REPO_NAME:doc
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: pull
    paths:
      - build

# DEPLOY_PHASE
#==============

deploy_assets:
  stage: deploy
  image: google/cloud-sdk:latest
  script:
    - echo $GCP_CREDENTIALS > /tmp/gcp_credentials.json
    - gcloud auth activate-service-account --key-file /tmp/gcp_credentials.json
    - gcloud config set project drmarkdown
    - gcloud container clusters get-credentials drmarkdown-cluster --region europe-west4-a --project drmarkdown
    - kubectl patch deployment doc-app-deployment -p "{\"spec\":{\"template\":{\"metadata\":{\"labels\":{\"date\":\"`date +'%s'`\"}}}}}"
  only:
    - master